import numpy as np
import matplotlib.pyplot as plt

############################################
####### load all clouds budget data ########
############################################

resultpath1 = '../budget_all_clouds/'

data1              = np.load(resultpath1+'conditional_avg_w_budget_all_clouds_1.npz')
data2              = np.load(resultpath1+'conditional_avg_w_budget_all_clouds_2.npz')
data3              = np.load(resultpath1+'conditional_avg_w_budget_all_clouds_3.npz')
data4              = np.load(resultpath1+'conditional_avg_w_budget_all_clouds_4.npz')

w_tend_tot1        = data1['w_tendency_cond_avg']
w_tend_pstep1      = data1['w_tend_pstep_cond_avg']
w_tend_pbstep1     = data1['w_tend_pbstep_cond_avg']
w_tend_pdstep1     = data1['w_tend_pdstep_cond_avg']
w_tend_damp1       = data1['w_tend_damp_cond_avg']
w_tend_buoy1       = data1['w_tend_buoy_cond_avg']
w_tend_vis1        = data1['w_tend_vis_cond_avg']
w_tend_adv1        = data1['w_tend_adv_cond_avg']
w_tend_sub1        = data1['w_tend_sub_cond_avg']
w_tend_ent1        = data1['w_tend_ent_cond_avg']

w_tend_tot2        = data2['w_tendency_cond_avg']
w_tend_pstep2      = data2['w_tend_pstep_cond_avg']
w_tend_pbstep2     = data2['w_tend_pbstep_cond_avg']
w_tend_pdstep2     = data2['w_tend_pdstep_cond_avg']
w_tend_damp2       = data2['w_tend_damp_cond_avg']
w_tend_buoy2       = data2['w_tend_buoy_cond_avg']
w_tend_vis2        = data2['w_tend_vis_cond_avg']
w_tend_adv2        = data2['w_tend_adv_cond_avg']
w_tend_sub2        = data2['w_tend_sub_cond_avg']
w_tend_ent2        = data2['w_tend_ent_cond_avg']

w_tend_tot3        = data3['w_tendency_cond_avg']
w_tend_pstep3      = data3['w_tend_pstep_cond_avg']
w_tend_pbstep3     = data3['w_tend_pbstep_cond_avg']
w_tend_pdstep3     = data3['w_tend_pdstep_cond_avg']
w_tend_damp3       = data3['w_tend_damp_cond_avg']
w_tend_buoy3       = data3['w_tend_buoy_cond_avg']
w_tend_vis3        = data3['w_tend_vis_cond_avg']
w_tend_adv3        = data3['w_tend_adv_cond_avg']
w_tend_sub3        = data3['w_tend_sub_cond_avg']
w_tend_ent3        = data3['w_tend_ent_cond_avg']

w_tend_tot4        = data4['w_tendency_cond_avg']
w_tend_pstep4      = data4['w_tend_pstep_cond_avg']
w_tend_pbstep4     = data4['w_tend_pbstep_cond_avg']
w_tend_pdstep4     = data4['w_tend_pdstep_cond_avg']
w_tend_damp4       = data4['w_tend_damp_cond_avg']
w_tend_buoy4       = data4['w_tend_buoy_cond_avg']
w_tend_vis4        = data4['w_tend_vis_cond_avg']
w_tend_adv4        = data4['w_tend_adv_cond_avg']
w_tend_sub4        = data4['w_tend_sub_cond_avg']
w_tend_ent4        = data4['w_tend_ent_cond_avg']


w_tend_tot_cld     = np.concatenate((w_tend_tot1, w_tend_tot2, w_tend_tot3, w_tend_tot4), axis=0)
w_tend_pstep_cld   = np.concatenate((w_tend_pstep1, w_tend_pstep2, w_tend_pstep3, w_tend_pstep4), axis=0)
w_tend_pbstep_cld  = np.concatenate((w_tend_pbstep1, w_tend_pbstep2, w_tend_pbstep3, w_tend_pbstep4), axis=0)
w_tend_pdstep_cld  = np.concatenate((w_tend_pdstep1, w_tend_pdstep2, w_tend_pdstep3, w_tend_pdstep4), axis=0)
w_tend_damp_cld    = np.concatenate((w_tend_damp1, w_tend_damp2, w_tend_damp3, w_tend_damp4), axis=0)
w_tend_buoy_cld    = np.concatenate((w_tend_buoy1, w_tend_buoy2, w_tend_buoy3, w_tend_buoy4), axis=0)
w_tend_vis_cld     = np.concatenate((w_tend_vis1, w_tend_vis2, w_tend_vis3, w_tend_vis4), axis=0)
w_tend_adv_cld     = np.concatenate((w_tend_adv1, w_tend_adv2, w_tend_adv3, w_tend_adv4), axis=0)
w_tend_sub_cld     = np.concatenate((w_tend_sub1, w_tend_sub2, w_tend_sub3, w_tend_sub4), axis=0)
w_tend_ent_cld     = np.concatenate((w_tend_ent1, w_tend_ent2, w_tend_ent3, w_tend_ent4), axis=0)

ncld   = 5

w_pstep_plt_cld    = np.mean(w_tend_pstep_cld, axis=0)[ncld,:] 
w_damp_plt_cld     = np.mean(w_tend_damp_cld, axis=0)[ncld,:] 
w_buoy_plt_cld     = np.mean(w_tend_buoy_cld, axis=0)[ncld,:] 
w_vis_plt_cld      = np.mean(w_tend_vis_cld, axis=0)[ncld,:] 
w_adv_plt_cld      = np.mean(w_tend_adv_cld, axis=0)[ncld,:] 
w_sub_plt_cld      = np.mean(w_tend_sub_cld, axis=0)[ncld,:] 
w_ent_plt_cld      = np.mean(w_tend_ent_cld, axis=0)[ncld,:] 

ncore   = 19

w_pstep_plt_core    = np.mean(w_tend_pstep_cld, axis=0)[ncore,:]
w_pbstep_plt_core   = np.mean(w_tend_pbstep_cld, axis=0)[ncore,:]
w_pdstep_plt_core   = np.mean(w_tend_pdstep_cld, axis=0)[ncore,:]
w_damp_plt_core     = np.mean(w_tend_damp_cld, axis=0)[ncore,:]
w_buoy_plt_core     = np.mean(w_tend_buoy_cld, axis=0)[ncore,:]
w_vis_plt_core      = np.mean(w_tend_vis_cld, axis=0)[ncore,:]
w_adv_plt_core      = np.mean(w_tend_adv_cld, axis=0)[ncore,:]
w_sub_plt_core      = np.mean(w_tend_sub_cld, axis=0)[ncore,:]
w_ent_plt_core      = np.mean(w_tend_ent_cld, axis=0)[ncore,:]

w_pstep_plt_core_val = w_pbstep_plt_core + w_pdstep_plt_core

##############################################
####### load tracked clouds budget data ######
##############################################
resultpath      = '../budget_tracked_clouds/'
data            = np.load(resultpath+'conditional_avg_w_budget_all_tracked_clouds.npz')
w_pstep_plt     = data['w_pstep_plt']
w_damp_plt      = data['w_damp_plt']
w_buoy_plt      = data['w_buoy_plt']
w_vis_plt       = data['w_vis_plt']
w_adv_plt       = data['w_adv_plt']
w_sub_plt       = data['w_sub_plt']
w_ent_plt       = data['w_ent_plt']
w_eff_buoy_plt  = data['w_eff_buoy_plt']
w_pbstep_plt    = data['w_pbstep_plt']
w_pdstep_plt    = data['w_pdstep_plt']
hgt             = data['hgt']

####################################
########## plot section ############
####################################
hs = 22
he = -1
####################################
w_zeros = np.zeros(w_pstep_plt_cld.shape)

fig, ax = plt.subplots(nrows=1, ncols=1,figsize=[7,16])

ax.plot(w_zeros[hs:he],hgt[hs:he],'-k',linewidth=2.5)
ax.plot(w_pstep_plt_cld[hs:he],hgt[hs:he],'-b',linewidth=1.5,label='$PGF$')
#ax.plot(w_damp_plt_cld[hs:he],hgt[hs:he],linestyle='-.',color=(0.5,0.5,0.5),linewidth=1.5,label='$DAMP$')
ax.plot(w_buoy_plt_cld[hs:he],hgt[hs:he],'-r',linewidth=1.5,label='$BUOY$')
ax.plot(w_vis_plt_cld[hs:he],hgt[hs:he],'-g',linewidth=1.5,label='$VIS$')
ax.plot(w_adv_plt_cld[hs:he],hgt[hs:he],'-y',linewidth=1.5,label='$ADV$')
ax.plot(w_sub_plt_cld[hs:he],hgt[hs:he],linestyle='-',color=(0.5,0.5,0.5),linewidth=1.5,label='$SUB$')
ax.plot(w_ent_plt_cld[hs:he],hgt[hs:he],'-m',linewidth=1.5,label='$ENT$')
ax.legend( loc = 4, fontsize=18)
ax.set_xlim([-0.015, 0.015])
ax.set_ylim([0, 2000])
ax.tick_params(axis='both', which='both', labelsize=18)
ax.ticklabel_format(style='sci',axis='x',scilimits=(0,0),useOffset=True)
ax.text(-0.013, 1900, '(a)', fontsize=20)
ax.set_xlabel('w tendency $(m s^{-2})$', fontsize=18)
ax.set_title('Cloud', fontsize=18)
ax.grid(True)

ax2=ax.twinx()
ax2.set_ylim([0, 2000])
ax2.set_yticks([0, 500, 1000, 1500, 2000])
ax2.set_yticklabels(['0', '$z_b$', '$2z_b$', '$3z_b$', '$4z_b$'],fontsize=18)

###############
w_zeros = np.zeros(w_pstep_plt_cld.shape)
fig, ax = plt.subplots(nrows=1, ncols=1,figsize=[7,16])

ax.plot(w_zeros[hs:he],hgt[hs:he],'-k',linewidth=2.5)
ax.plot(w_pstep_plt[hs:he],hgt[hs:he],'-b',linewidth=1.5,label='$PGF$')
#ax.plot(w_damp_plt_cld[hs:he],hgt[hs:he],linestyle='-.',color=(0.5,0.5,0.5),linewidth=1.5,label='$DAMP$')
ax.plot(w_buoy_plt[hs:he],hgt[hs:he],'-r',linewidth=1.5,label='$BUOY$')
ax.plot(w_vis_plt[hs:he],hgt[hs:he],'-g',linewidth=1.5,label='$VIS$')
ax.plot(w_adv_plt[hs:he],hgt[hs:he],'-y',linewidth=1.5,label='$ADV$')
ax.plot(w_sub_plt[hs:he],hgt[hs:he],linestyle='-',color=(0.5,0.5,0.5),linewidth=1.5,label='$SUB$')
ax.plot(w_ent_plt[hs:he],hgt[hs:he],'-m',linewidth=1.5,label='$ENT$')
ax.set_xlim([-0.015, 0.015])
ax.set_ylim([0, 2000])
ax.tick_params(axis='both', which='both', labelsize=18)
ax.ticklabel_format(style='sci',axis='x',scilimits=(0,0),useOffset=True)
ax.text(-0.013, 1900, '(b)', fontsize=20)
ax.set_xlabel('w tendency $(m s^{-2})$', fontsize=18)
ax.set_title('Tracked Cloud', fontsize=18)
ax.grid(True)

ax2=ax.twinx()
ax2.set_ylim([0, 2000])
ax2.set_yticks([0, 500, 1000, 1500, 2000])
ax2.set_yticklabels(['0', '$z_b$', '$2z_b$', '$3z_b$', '$4z_b$'],fontsize=18)

##############
w_zeros = np.zeros(w_pstep_plt_cld.shape)
fig, ax = plt.subplots(nrows=1, ncols=1,figsize=[7,16])

ax.plot(w_zeros[hs:he],hgt[hs:he],'-k',linewidth=2.5)
ax.plot(w_pstep_plt[hs:he],hgt[hs:he],'-b',linewidth=1.5,label='$PGF$')
ax.plot(w_buoy_plt[hs:he],hgt[hs:he],'-r',linewidth=1.5,label='$BUOY$')
ax.plot(w_pbstep_plt[hs:he],hgt[hs:he],'-.b',linewidth=1.5,label='$PBGF$')
ax.plot(w_pdstep_plt[hs:he],hgt[hs:he],':b',linewidth=1.5,label='$PDGF$')
ax.plot(w_zeros[hs:he],hgt[hs:he],'-k',linewidth=1.5)
ax.legend( loc = 4, fontsize=18)
ax.set_xlim([-0.015, 0.015])
ax.set_ylim([0, 2000])
ax.tick_params(axis='both', which='both', labelsize=18)
ax.ticklabel_format(style='sci',axis='x',scilimits=(0,0),useOffset=True)
ax.text(-0.013, 1900, '(c)', fontsize=20)
ax.set_xlabel('w tendency $(m s^{-2})$', fontsize=18)
ax.set_title('Tracked Cloud', fontsize=18)
ax.grid(True)

ax2=ax.twinx()
ax2.set_ylim([0, 2000])
ax2.set_yticks([0, 500, 1000, 1500, 2000])
ax2.set_yticklabels(['0', '$z_b$', '$2z_b$', '$3z_b$', '$4z_b$'],fontsize=18)

##############
w_zeros = np.zeros(w_pstep_plt_cld.shape)
fig, ax = plt.subplots(nrows=1, ncols=1,figsize=[7,16])

ax.plot(w_zeros[hs:he],hgt[hs:he],'-k',linewidth=2.5)
ax.plot(w_pstep_plt_core[hs:he],hgt[hs:he],'-b',linewidth=1.5,label='$PGF$')
ax.plot(w_buoy_plt_core[hs:he],hgt[hs:he],'-r',linewidth=1.5,label='$BUOY$')
ax.plot(w_pbstep_plt_core[hs:he],hgt[hs:he],'-.b',linewidth=1.5,label='$PBGF$')
ax.plot(w_pdstep_plt_core[hs:he],hgt[hs:he],':b',linewidth=1.5,label='$PDGF$')
ax.legend( loc = 4, fontsize=18)
ax.set_xlim([-0.02, 0.02])
ax.set_ylim([0, 2000])
ax.set_xticks([-0.02,-0.015,-0.01,-0.005,0,0.005,0.01,0.015,0.02])
ax.tick_params(axis='both', which='both', labelsize=18)
ax.ticklabel_format(style='sci',axis='x',scilimits=(0,0),useOffset=True)
ax.text(-0.018, 1900, '(d)', fontsize=20)
ax.set_xlabel('w tendency $(m s^{-2})$', fontsize=18)
ax.set_title('Updraft core', fontsize=18)
ax.grid(True)

ax2=ax.twinx()
ax2.set_ylim([0, 2000])
ax2.set_yticks([0, 500, 1000, 1500, 2000])
ax2.set_yticklabels(['0', '$z_b$', '$2z_b$', '$3z_b$', '$4z_b$'],fontsize=18)

##############################
plt.show()



