import numpy as np
import matplotlib.pyplot as plt
import pickle
from mpl_toolkits.mplot3d import Axes3D

##############################################
########## load cloud tracking data ##########
##############################################
resultpath         = '../cloud_track/'

cloud_track_pos         = pickle.load(open(resultpath+'cloud_track_position.pkl','rb'))

##############################################
############### Plot section #################
##############################################
cld_id_list = [50, 1, 222] 

for cld_id in cld_id_list:

    zcor = cloud_track_pos[cld_id][0][0] 
    ycor = cloud_track_pos[cld_id][1][0] 
    xcor = cloud_track_pos[cld_id][2][0] 

    fig = plt.figure(figsize=[10,10])
    ax  = Axes3D(fig)
    ax.set_zlabel('Z')
    ax.set_ylabel('Y')
    ax.set_xlabel('X')
    ax.set_xlim([0, 600])
    ax.set_ylim([0, 600])
    ax.set_zlim([0, 100])
    ax.scatter(xcor, ycor, zcor, c='b')

    clist = ['r','y','g','c','m','k',(0.5,0.5,0.5)]

    for num in range(1, len(cloud_track_pos[cld_id][0])):

        zcor = cloud_track_pos[cld_id][0][num]
        ycor = cloud_track_pos[cld_id][1][num]
        xcor = cloud_track_pos[cld_id][2][num]

        cindex = np.mod(num-1, len(clist))
        ax.scatter(xcor, ycor, zcor, c=clist[cindex])

    ax.view_init(azim=270, elev=90)

############

plt.show()



